/***************************************
	Auteur : Pierre Aubert
	Mail : pierre.aubert@lapp.in2p3.fr
	Licence : CeCILL-C
****************************************/
#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

//Some doc at : https://en.cppreference.com/w/cpp/header/execution
#include <execution>
int main(int argc, char** argv){
	size_t nbElement(100000000);
	std::vector<float> tabX(nbElement), tabY(nbElement), tabRes(nbElement);
	std::generate(std::execution::par_unseq, tabX.begin(), tabX.end(), [i = 0] () mutable {
		float val(i*19lu%11);
		i++;
		return val;
	});
	std::generate(std::execution::par_unseq, tabY.begin(), tabY.end(), [i = 0] () mutable {
		float val(i*27lu%19);
		i++;
		return val;
	});
	std::transform(std::execution::par_unseq, std::begin(tabX), std::end(tabX), std::begin(tabY), std::begin(tabRes),
			[](float xi, float yi){ return xi * yi; });
	std::cout << "x = " << tabX.front() << ", y = " << tabY.front() << ", res = " << tabRes.front() << std::endl;
	return 0;
}

